	// ===============================================================
	// EditHandler Flags
	// ===============================================================	
	
	function HTTP_LOAD()
	{
		// Escape if new item
		// ...........................................
		if(JSRC_FLAG.IS_NULL_BIGINT(PROPERTY_ACC_LEVEL_ID, 1, 1))
		{
			return;
		}
		
		
		// Load DB data of item
		// ...........................................
		JSOC_DIALOG.VAR_LOADING_SPINNER(true);
		JSCUS_SQL._ACCOUNT._LEVEL.CUS_GET_THEN_POPULATE_FORM
		(
			function(){CUS_SEND_DIALOG_TRY_DISMISS();},
			
			"LEVEL_MODAL", 
			FLAG_TINYINT_NULL, 
			PROPERTY_ACC_LEVEL_ID
		);
		
		
		// Clear Changes due to loading
		// ...........................................
		
	}


	// ===============================================================
	// Trims empty spaces and perform convertion for numeric fields.
	// ===============================================================
	function FIX_INPUT()
	{
		// Fix String Fields
		// ...........................................
		JSOC_INPUT_TEXT.CTL_TRIM(ACC_LEVEL_DESCRIPTION_TXT);
		
		
		// Fix Numeric Fields (if field type is not number.)
		// ...........................................


		// Fix Password Fields
		// ...........................................
	}

		
	// ===============================================================
	// Request Save
	// ===============================================================
	function HTTP_SAVE(CALLBACK_METHOD)
	{

		// Sanitize User Inputs
		// _______________________________________________________________________
		FIX_INPUT();
	
	
		// Check Edit Status
		// _______________________________________________________________________
		if(EDIT_HANDLER.REF_IS_MODIFIED == false)
		{
			JSVC_INFO.VAR_NOTHING_TO_SAVE(function(){CALLBACK_METHOD(false);})	
			return;		
		}


		// Validate Null [String Input]
		// _______________________________________________________________________
		if(JSOC_INPUT_TEXT.CTL_VALIDATE(ACC_LEVEL_DESCRIPTION_TXT, "Description", null, 1, 500) == false)
		{
			return false;
		}
		
		
		// Validate Zero [Numeric Input]
		// _______________________________________________________________________
	
	
		// Validate Negative [Numeric Input]
		// _______________________________________________________________________
		
		
		// Validate Range [Numeric Input]
		// _______________________________________________________________________	


		// Foreign key check
		// _______________________________________________________________________
		

		// Validate Duplicates
		// _______________________________________________________________________
		var EXCEPTION_ROW_INDEX = -1;
		if(PROPERTY_ACC_LEVEL_ID >= 0)
		{
			EXCEPTION_ROW_INDEX = PROPERTY_EDIT_ROW_INDEX;
		}
			

		
		
		// Password Items (if available)
		// _______________________________________________________________________
		
		
		// CheckBox Items (if available)
		// _______________________________________________________________________
			
		// Internal Data Variables
		// _______________________________________________________________________
		var INTERNAL_DATA_ACC_LEVEL_SERVER_ID = FLAG_BIGINT_NULL;
		var INTERNAL_DATA_ACC_LEVEL_TAG_ID = FLAG_BIGINT_NULL;

		// Internal Data Processes
		// _______________________________________________________________________
		// Todo add internal processes here
		
		// Save item [Prepare]
		// _______________________________________________________________________
		var SAVE_MAP_ARRAY = JSCUS_SQL._ACCOUNT._LEVEL.CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
		// JSVC_MAP_ARRAY.VAR_SET(GET_MAP_ARRAY, 'PARAM_PARENT_ID', PROPERTY_PARENT_ID));		// Parent ID Sample
		JSVC_MAP_ARRAY.VAR_SET(SAVE_MAP_ARRAY, "PARAM_ACC_LEVEL_ID", PROPERTY_ACC_LEVEL_ID);				
		
		JSVC_MAP_ARRAY.VAR_SET(SAVE_MAP_ARRAY, "PARAM_ACC_LEVEL_SERVER_ID", 0);				
		JSVC_MAP_ARRAY.VAR_SET(SAVE_MAP_ARRAY, "PARAM_ACC_LEVEL_TAG_ID", 0);				
		JSVC_MAP_ARRAY.VAR_SET(SAVE_MAP_ARRAY, "PARAM_ACC_LEVEL_DESCRIPTION", JSOC_ELEMENT.VAR_VALUE(ACC_LEVEL_DESCRIPTION_TXT));					
		JSVC_MAP_ARRAY.VAR_SET(SAVE_MAP_ARRAY, "PARAM_ACC_LEVEL_STATUS", JSVC_NUM.VAR_NVALL(JSOC_CMB.VAR_SELECTED_VALUE(ACC_LEVEL_STATUS_CMB)));
		
		
		// Declare Post Request Handler
		// _______________________________________________________________________
		var RESPONSE_HANDLER = 			
			function(IS_SUCCESS, HTTP_RESPONSE)
			{
				// Handle Error
				// ...........................................
				if(IS_SUCCESS === false)
				{
					METHOD_UNABLE_TO_SEND_REQUEST(CALLBACK_METHOD);	
					return;
				}
				
				// Catch JSON Error
				// ...........................................
				else if(JSRC_JSON.REF_IS_JSTRING(HTTP_RESPONSE) == false)
				{
					METHOD_SERVER_ISSUE(CALLBACK_METHOD, HTTP_RESPONSE);
					return;			
				}
					
				// Read Response
				// ...........................................
				else
				{
					// Load Response
					var JSON_OBJECT = JSRC_JSON.REF_CREATE(HTTP_RESPONSE);
					if(JSRC_JSON.REF_IS_SUCCESS(JSON_OBJECT) === false)
					{
						METHOD_REQUEST_FAILURE(CALLBACK_METHOD, JSON_OBJECT);
						return;
					}
					
			
					// Post Save Action
					else
					{
						// Retrieve Inserted ID
						PROPERTY_ACC_LEVEL_ID = JSRC_JSON.REF_READ(JSON_OBJECT, "INSERTED_ID");
						
						// Update Changes to DataGridView
						if(PROPERTY_ACC_LEVEL_ID > 0)
						{
							JSOC_DGV_CELL.VAR_VALUE 
								(
									LEVEL_DGV,
									"ACC_LEVEL_DESCRIPTION", 
									PROPERTY_EDIT_ROW_INDEX, 
									JSOC_ELEMENT.VAR_VALUE(ACC_LEVEL_DESCRIPTION_TXT),
									true
								);
							JSOC_DGV_CELL.VAR_VALUE
								(
									LEVEL_DGV,
									"ACC_LEVEL_STATUS", 
									PROPERTY_EDIT_ROW_INDEX, 
									JSOC_CMB.VAR_SELECTED_TEXT(ACC_LEVEL_STATUS_CMB),
									true
								);
						}
						else
						{
							HTTP_SEARCH();
						}	

						// Lift edit and Exit EditMode
						EDIT_HANDLER.REF_IS_MODIFIED = false;
						EDIT_HANDLER.HAS_NEWLY_SAVED_DATA = true;			
						if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS('LEVEL_MODAL') == true)
						{
							JSOC_DIALOG.VAR_MODAL('LEVEL_MODAL', false);
						}
						
						//SWAP_EDIT_MODE(false);
						CALLBACK_METHOD(true);											
					}
				}
			};
			
			
		// Save Item [Send Request]
		// _______________________________________________________________________
		JSCUS_SQL._ACCOUNT._LEVEL.CUS_SAVE 
		(
			SAVE_MAP_ARRAY,
			RESPONSE_HANDLER
		);
		
	}
	
	
	function HTTP_DELETE(CALLBACK_METHOD, ROW_INDEX)
	{
		// Escaper if Disabled
		// _______________________________________________________________________
		if(JSVC_VAR.VAR_ISSET(DELETE_BBI) && DELETE_BBI.Enabled == false)
		{
			CALLBACK_METHOD(false);
			return;
		}

		// Escape if nothing selected
		// _______________________________________________________________________
		if(ROW_INDEX < 0)
		{
			JSVC_ERROR.VAR_ARGUMENT_EXCEPTION_NOTHING_SELECTED(true);
			CALLBACK_METHOD(false);
			return;
		}
		
		// Initialize
		// _______________________________________________________________________
		var DELETE_ITEM_DESCRIPTION = LEVEL_DGV.CELL.VALUE('ACC_LEVEL_DESCRIPTION', ROW_INDEX);
		
		// Should not edit a System Generated items.
		// _______________________________________________________________________
		if 
		(
			JSVC_NUM.VAR_NVALI(LEVEL_DGV.CELL.VALUE('ACC_LEVEL_SYSTEM_GENERATED', ROW_INDEX)) == JSCUS_SQL._SYSTEM._STATUS.STATUS_ACTIVE
		)
		{
			JSOC_DIALOG.VAR_MESSAGE_BOX
				(
					'Request denied: This item is system generated.',
					'Information',
					'OK', 'WARNING',
					function()
					{
						CALLBACK_METHOD(false);
					}
				);	
			return;		
		}	
		
		
		// Declare Post Request Handler
		// _______________________________________________________________________
		var RESPONSE_HANDLER = function
		(
			IS_SUCCESS, 
			HTTP_RESPONSE
		)
		{
			// Disable Dialogs
			// ...........................................
			CUS_SEND_DIALOG_TRY_DISMISS();
				
				
			// Handle Error
			// ...........................................
			if(IS_SUCCESS === false)
			{
				METHOD_UNABLE_TO_SEND_REQUEST(CALLBACK_METHOD);
				return;
			}
			
			// Catch JSON Error
			// ...........................................
			else if(JSRC_JSON.REF_IS_JSTRING(HTTP_RESPONSE) == false)
			{
				METHOD_SERVER_ISSUE(CALLBACK_METHOD, HTTP_RESPONSE);
				return;			
			}
			
			
			// Read Response
			// ...........................................
			else
			{
				// Load Response
				var JSON_OBJECT = JSRC_JSON.REF_CREATE(HTTP_RESPONSE);
				if(JSRC_JSON.REF_IS_SUCCESS(JSON_OBJECT) === false)
				{
					METHOD_REQUEST_FAILURE(CALLBACK_METHOD, JSON_OBJECT);
					return;
				}
				
				// Post Delete Action
				else
				{
					LEVEL_DGV.ROW.REMOVE_AT(ROW_INDEX);
					LEVEL_DGV.COLUMN.ROW_COUNT_PRINT('ROW_COUNT');
					JSVC_INFO.VAR_RECORD_DELETED
					(
						DELETE_ITEM_DESCRIPTION, 
						function()
						{
							CALLBACK_METHOD(true);
						}
					);		
				}
			}
		};
		
		
		// Request User Verification for Delete
		// _______________________________________________________________________
		JSVC_INFO.VAR_VERIFY_DELETE
		(
			DELETE_ITEM_DESCRIPTION,
			function(VERIFY_RESULT) 
			{
				// Abort if rejected by user.
				// ...........................................
				if(VERIFY_RESULT != JSOC_DIALOG.MSGBOX_YES)
				{

					CALLBACK_METHOD(false);
					return;
				}
				
				
				//Delete Item
				// ...........................................
				JSOC_DIALOG.VAR_LOADING_SPINNER(true);
				JSCUS_SQL._ACCOUNT._LEVEL.CUS_DELETE
				(
					LEVEL_DGV.CELL.VALUE('ACC_LEVEL_ID', ROW_INDEX),
					RESPONSE_HANDLER
				)
			}
		);
	}